; ---------------------------------------------------------------
; Dieser Quelltext ist urheberrechtlich geschuetzt.              
; (c) 1991-1999 Peter Mandrella                                  
; (c) 2000-2001 OpenXP-Team                                      
; (c) 2002-2005 FreeXP, http://www.freexp.de                     
; CrossPoint ist eine eingetragene Marke von Peter Mandrella.    
;                                                                
; Die Nutzungsbedingungen fuer diesen Quelltext finden Sie in der
; Datei SLIZENZ.TXT oder auf www.crosspoint.de/oldlicense.html.  
; ---------------------------------------------------------------
; $Id: xms.asm,v 1.2.2.7 2005/01/01 09:56:47 mw Exp $
; Routinen fr XMS.PAS


           .model tpascal
           .286

           .data

           extrn   xmsok   : byte
           extrn   xmscall : dword
           extrn   result  : byte

movelength dd      ?
srchandle  dw      ?
srcoffset  dd      ?
dsthandle  dw      ?
dstoffset  dd      ?

           .code

           public  XmsVersion
           public  XmsTotal
           public  XmsAvail
           public  XmsAlloc
           public  XmsRealloc
           public  XmsFree
           public  XmsRead
           public  XmsWrite


errcheck:  cmp     ax,1
           jnz     ec2
           mov     result,0
           ret
ec2:       mov     result,bl
           ret


; function XmsVersion:word; external;

XmsVersion proc    far
           mov     ax,0
           cmp     xmsok,1
           jnz     e0
           call    dword ptr xmscall
           mov     bx,ax               ; BCD-Zahl in AL -> Dez-Zahl
           shr     al,4
           mov     ah,10
           mul     ah
           and     bl,0fh
           add     ax,bx
e0:        ret
XmsVersion endp


; function XmsTotal:word; external;

XmsTotal   proc    far
           mov     ax,0
           cmp     xmsok,1
           jnz     e1
           mov     ah,8
           call    dword ptr xmscall
           mov     ax,dx
e1:        ret
XmsTotal   endp

; function XmsAvail:word; external;

XmsAvail  proc     far
          mov      ax,0
          cmp      xmsok,1
          jnz      e2
          mov      ah,8               ; xmsvail (orig,)
          call     dword ptr xmscall
          mov      di,dx              ; dx=total free XMS
          mov      cx,dx
          mov      si,ax              ; ax=biggest free EMB
          cmp      dx,16384
          ja       e20                ; total free >16 Mb
          jmp      e21
e20:      mov      ah,9               ; xmsalloc
          call     dword ptr xmscall
          cmp      ax,1
          je       e24                ; total free >16 Mb Kb ok
e21:      mov      di,16384           ; 16 Mb
          mov      dx,di
          mov      ah,9               ; xmsalloc
          call     dword ptr xmscall
          cmp      ax,1
          je       e24                ; 16 Mb ok
          mov      di,15215           ; ca. 15 Mb
          mov      dx,di
          mov      ah,9               ; xmsalloc
          call     dword ptr xmscall
          cmp      ax,1
          je       e24                ; ca. 15 Mb ok
          cmp      cx,15214
          jbe      e22                ; <= 15214 Kb
          jmp      e23                ; discard dx
e22:      cmp      cx,0               ; total free XMS=0
          mov      ax,0
          je       e2
          mov      di,cx
          mov      dx,di
          mov      ah,9               ; xmsalloc
          call     dword ptr xmscall
          cmp      ax,1
          je       e24                ; <= 15214 Kb ok
e23:      mov      ax,si
          jmp      e2
e24:      mov      ah,0ah             ; xmsfree
          call     dword ptr xmscall
          mov      ax,di
e2:       ret
XmsAvail  endp


; function  XmsAlloc(KB:word):word; external;

XmsAlloc  proc     far, KB:word
          cmp      xmsok,1
          jnz      e3
          mov      dx,KB
          mov      ah,9
          call     dword ptr xmscall
          call     errcheck
          mov      ax,dx
e3:       ret
XmsAlloc  endp


; procedure XmsRealloc(handle:word; KB:word); external;

XmsRealloc proc    far, handle:word, KB:word
          cmp      xmsok,1
          jnz      e4
          mov      dx,handle
          mov      bx,KB
          mov      ah,15
          call     dword ptr xmscall
          call     errcheck
e4:       ret
XmsRealloc endp


; procedure XmsFree(handle:word); external;

XmsFree   proc     far, handle:word
          cmp      xmsok,1
          jnz      e5
          mov      dx,handle
          mov      ah,10
          call     dword ptr xmscall
          call     errcheck
e5:       ret
XmsFree   endp


; procedure XmsRead(handle:word; var data; offset,size:longint); external;

XmsRead   proc     far, handle:word, d:dword, off:dword, siz:dword
          cmp      xmsok,1
          jnz      e6
          test     word ptr siz,1
          jz       even1
          add      word ptr siz,1      ; Size auf gerade Zahl aufrunden
          adc      word ptr siz+2,0
even1:    les      si,siz
          mov      word ptr movelength,si
          mov      word ptr movelength+2,es
          mov      ax,handle
          mov      srchandle,ax
          les      si,off
          mov      word ptr srcoffset,si
          mov      word ptr srcoffset+2,es
          mov      dsthandle,0
          les      si,d
          mov      word ptr dstoffset,si
          mov      word ptr dstoffset+2,es
          mov      si,offset movelength
          mov      ah,11
          call     dword ptr xmscall
          call     errcheck
e6:       ret
XmsRead   endp


; procedure XmsWrite(handle:word; var data; offset,size:longint); external;

XmsWrite  proc     far, handle:word, d:dword, off:dword, siz:dword
          cmp      xmsok,1
          jnz      e7
          test     word ptr siz,1
          jz       even2
          add      word ptr siz,1      ; Size auf gerade Zahl aufrunden
          adc      word ptr siz+2,0
even2:    les      si,siz
          mov      word ptr movelength,si
          mov      word ptr movelength+2,es
          mov      srchandle,0
          les      si,d
          mov      word ptr srcoffset,si
          mov      word ptr srcoffset+2,es
          mov      ax,handle
          mov      dsthandle,ax
          les      si,off
          mov      word ptr dstoffset,si
          mov      word ptr dstoffset+2,es
          mov      si,offset movelength
          mov      ah,11
          call     dword ptr xmscall
          call     errcheck
e7:       ret
XmsWrite  endp


          end

; JM 17.06.04
; - den folgenden Kommentar von MW vom 16.9.03 leicht verndert/erweitert:
;
; MW 16.09.03:
; - bernahme der XMS.ASM und XMS.OBJ von FreeXP 3.40 (Stand vom 05.05.03):
;   - Unter Win9x knnen jetzt auch bei FreeXP 3.20 statt 2 MB
;     bis zu 64 MB XMS benutzt werden.
;   - Unter Windows NT/2000 werden jetzt bis zu 15215 KB XMS,
;     unter Windows XP bis zu 16 MB XMS benutzt.
;     Mehr ist aufgrund von Beschrnkungen des Betriebsystems nicht mglich.
;
; Die Menge des tatschlich nutzbaren XMS-Speichers wird zunchst versucht
; empirisch zu ermitteln, statt den mitunter fehlerhaften Angaben sowohl
; von Windows 9x/Me als auch von Windows NT/2000/XP Glauben zu schenken.
; Ausfhrlichere Beschreibung siehe FreeXP 3.40

