{ --------------------------------------------------------------- }
{ Dieser Quelltext ist urheberrechtlich geschuetzt.               }
{ (c) 1991-1999 Peter Mandrella                                   }
{ (c) 2000-2001 OpenXP-Team                                       }
{ (c) 2002-2005 FreeXP, http://www.freexp.de                      }
{ CrossPoint ist eine eingetragene Marke von Peter Mandrella.     }
{                                                                 }
{ Die Nutzungsbedingungen fuer diesen Quelltext finden Sie in der }
{ Datei SLIZENZ.TXT oder auf www.crosspoint.de/oldlicense.html.   }
{ --------------------------------------------------------------- }
{ $Id: xpx.pas,v 1.7.2.7 2005/01/01 09:56:52 mw Exp $ }

{ CrossPoint - First Unit }

unit xpx;

{$I XPDEFINE.INC }

interface

uses
{$IFDEF BP }
  ems,
{$ENDIF }
  crt, dos,dosx,typeform,fileio,mouse,inout,xp0,xpcrc32, xpglobal;

implementation

{$IFDEF BP }
  {$IFDEF DPMI}
  const MinVersion = $330;
        MinVerStr  = '3.3';
        MaxHandles = 41;
  {$ELSE}
  uses  overlay;
  const MinVersion = $300;
        MinVerStr  = '3.0';
        MaxHandles = 40;
  var   handles    : array[1..maxhandles] of byte;
  {$ENDIF}
{$ENDIF}

const starting : boolean = true;

var oldexit : pointer;


procedure stop(txt:string);
begin
  writeln;
  writeln(txt);
  runerror:=false;
  halt(1);
end;

function _deutsch:boolean;
var t : text;
    s : string;
begin
  filemode:=0;
  assign(t,'xp.res');
  reset(t);
  readln(t,s);
  close(t);
  _deutsch:=(ioresult=0) and (ustr(s)='XP-D.RES');
  filemode:=2;
end;

procedure logo;
var t : text;
begin
  assign(t,'');
  rewrite(t);
  writeln(t);
  write(t,xp_xp);
  if (xp_xp='CrossPoint') then write(t,'(R)');
  writeln(t,' ',verstr,betastr);
  writeln(t,x_copyright,' by ',author_name,' (',author_mail,')');
  writeln(t);
  if _deutsch then
  begin
    writeln(t,'basierend auf CrossPoint(R) v3.2  (c) 1992-1999 Peter Mandrella');
  end else
  begin
    writeln(t,'based on CrossPoint(R) v3.2  (c) 1992-1999 Peter Mandrella');
  end;
  writeln(t);
  close(t);
end;

procedure readname;
var t    : text;
    name : string[10];
    short: string[2];
    code : string[20];
begin
  assign(t,progpath+'pname.dat');
  if existf(t) then begin
    reset(t);
    readln(t,name);
    readln(t,short);
    readln(t,code);
    close(t);
    if (ioresult=0) and
       (ival(code)=sqr(CRC32(reverse(name)) and $ffff)) then begin
      XP_xp:=name;
      XP_origin := '--- '+name;
      end;
    end;
end;

{$IFDEF BP }
procedure SetHandles;
var i    : integer;
    regs : registers;
begin
  {$IFNDEF DPMI }
    for i:=1 to maxhandles do
      handles[i]:=$ff;
    for i:=1 to 5 do
      handles[i]:=mem[PrefixSeg:$18+pred(i)];
    MemW[PrefixSeg:$32] := MaxHandles;
    MemW[PrefixSeg:$34] := Ofs(handles);
    MemW[PrefixSeg:$36] := Seg(handles);
  {$ELSE}
    with regs do begin
      ah:=$67;
      bx:=maxhandles;
      msdos(regs);
      if flags and fcarry<>0 then
        writeln('Warnung: Fehler beim Anfordern von File Handles!');
      end;
  {$ENDIF}
end;
{$ENDIF }

{$IFDEF BP }
procedure TestOVR;
var ft   : longint;
    c,cc : char;
begin
  if not exist('xp.ovr') then
    stop('Die Datei XP.OVR fehlt!');
  ft:=filetime('xp.exe');
  if (ft<>0) and (abs(ft-filetime('xp.ovr'))>=60) then begin
    writeln;
    writeln('WARNUNG: Das Dateidatum von XP.OVR stimmt nicht mit dem von XP.EXE');
    writeln('         berein. XP.OVR stammt offenbar von einer anderen '+xp_display+'-');
    writeln('         Version. Bitte spielen Sie das Programm aus einem '+xp_display+'-');
    writeln('         Originalarchiv neu auf! Wenn Sie das Programm jetzt fortsetzen,');
    writeln('         wird es wahrscheinlich abstrzen.');
    writeln;
    writeln('         Falls Sie nach einem Neuaufspielen wieder die gleiche Fehler-');
    writeln('         meldung erhalten, ist Ihr Rechner mglicherweise mit einem');
    writeln('         Virus infiziert.');
    writeln;
    write(#7'Programm fortsetzen (J/N)? ');
    c:='N';
    repeat
      write(c,#8);
      cc:=readkey;
      case cc of
        #0 : if readkey='' then;
        'j','J' : c:='J';
        'n','N' : c:='N';
      end;
    until (cc=#13) or (cc=#27);
    writeln;
    if (cc=#27) or (c='N') then begin
      runerror:=false;
      halt(1);
      end;
    end;
end;
{$ENDIF }

{$S-}
procedure setpath; {$IFNDEF Ver32 } far; {$ENDIF }
begin
  if ioresult = 0 then ;
  GoDir(shellpath);
  if ioresult<>0 then GoDir(ownpath);
  if runerror and not starting then begin
    attrtxt(7);
    writeln;
    writeln('Fehler: ',ioerror(exitcode,'<interner Fehler>'));
    end;
  exitproc:=oldexit;
end;
{$IFDEF Debug }
  {$S+}
{$ENDIF }


procedure TestCD;
var f    : file;
    attr : smallword;
begin
  assign(f,paramstr(0));
  getfattr(f,attr);
  if attr and ReadOnly<>0 then begin
    assign(f,OwnPath+'XP$T.$1');
    rewrite(f);
    if ioresult=0 then begin
      close(f);
      erase(f);
      end
    else begin
      writeln;
      writeln(xp_display+' kann nicht von einem schreibgeschtzten Laufwerk gestartet');
      writeln('werden. Kopieren Sie das Programm bitte auf Festplatte.');
      runerror:=false;
      halt(1);
      end;
    end;
end;

begin
  checkbreak:=false;
{$IFDEF BP } { Die Abfrage der DOS-Version ist nur bei 16 Bit sinnvoll }
  if swap(dosversion)<MinVersion then
    stop('DOS Version '+MinVerStr+' oder hher erforderlich.');
{$ENDIF }
  readname;
  if left(getenv('PROMPT'),4)='[XP]' then
    if _deutsch then stop('Zurck zu CrossPoint mit EXIT.')
    else stop('Type EXIT to return to CrossPoint.');
{$IFDEF BP }
  SetHandles;
{$ENDIF }
  ShellPath:=dospath(0);
  if Shellpath+'\'<>progpath then
    GoDir(progpath);
  oldexit:=exitproc;
  exitproc:=@setpath;
  mausunit_init;
  logo;
{$IFDEF BP }            { alles andere sind sowieso 32 Bit Versionen }
  {$IFNDEF NO386 }      { Die XT Version darf hier nicht testen }
  if Test8086 < 2 then
  begin
    Writeln(xp_display+' luft in dieser Version erst ab 386er CPUs mit CoProzessor.');
    Writeln('Eine XT-Version kann von der Homepage '+author_url+' bezogen werden.');
    runerror := false;
    Halt(1);
  end;
  {$ENDIF }
{$ENDIF }

{$IFDEF BP }      { Unter 32 Bit haben wir keine Overlays }
  {$IFNDEF DPMI}     { mit DPMI auch nicht }
    TestOVR;
    OvrInit('xp.ovr');
    if EmsTest and (ustr(left(paramstr(1),4))<>'/AV:') and (paramstr(1)<>'/?') then
      OvrInitEMS;
    OvrSetBuf(OvrGetBuf+40000);   { > CodeSize(MASKE.TPU) }
  {$ENDIF}
{$ENDIF}

  OwnPath:=progpath;
  if ownpath='' then getdir(0,ownpath);
  if right(ownpath,1)<>'\' then
    ownpath:=ownpath+'\';
  if cpos(':',ownpath)=0 then begin
    if left(ownpath,1)<>'\' then ownpath:='\'+ownpath;
    ownpath:=getdrive+':'+ownpath;
    end;
  UpString(ownpath);
  TestCD;
  starting:=false;
end.
{
  $Log: xpx.pas,v $
  Revision 1.7.2.7  2005/01/01 09:56:52  mw
  MW: - Willkommen im Jahr 2005

  Revision 1.7.2.6  2004/01/09 13:57:35  mw
  MW: - Wir haben jetzt 2004!!

  Revision 1.7.2.5  2003/12/17 07:14:22  mw
  JM: - Crosspoint/FreeXP 3.21 ist nun Freeware

  Revision 1.7.2.4  2003/12/14 14:02:53  mw
  MW: - Nochmalige Korrektur der Quellcodeheader

  Revision 1.7.2.3  2003/12/14 10:47:43  mw
  MW: - Quelltextheader an FreeXP angepasst.

  Revision 1.7.2.2  2003/09/23 07:16:29  mw
  MW: - Filehandle-Array auf 40 vergrert.
        (Vervollstndigung einer nderung von MK)

  Revision 1.7.2.1  2000/11/17 22:34:38  mk
  - OpenXP erscheint jetzt ab und zu auch mal oeffentlich ;)

  Revision 1.7  2000/03/02 18:32:24  mk
  - Code ein wenig aufgeraeumt

  Revision 1.6  2000/02/19 11:40:09  mk
  Code aufgeraeumt und z.T. portiert

  Revision 1.5  2000/02/15 20:43:37  mk
  MK: Aktualisierung auf Stand 15.02.2000

}
